using System;
using System.Collections;
using System.Collections.Generic;
using System.Data;
using System.Configuration;
using System.Data.OleDb;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Telerik.WebControls;

public partial class _Default : System.Web.UI.Page 
{
    Hashtable selectedItemsPerPage;
    Hashtable selectedIndexesPerPage;
    bool shouldUpdateHashtables = false; //used on sorting
    protected void Page_Load(object sender, EventArgs e)
    {}

    protected void RadGrid1_SortCommand(object source, GridSortCommandEventArgs e)
    {
        SaveSelectedItemsPerPage();
        shouldUpdateHashtables = true;
    }

    protected void RadGrid1_PreRender(object sender, EventArgs e)
    {
        if (shouldUpdateHashtables)
        {
            UpdatePageSelectedItems();
            shouldUpdateHashtables = false;
        }
        UpdateHiddenInputValue();
    }
    protected void RadGrid1_PageIndexChanged(object source, GridPageChangedEventArgs e)
    {
        SaveSelectedItemsPerPage();
    }
    protected void RadGrid1_NeedDataSource(object source, GridNeedDataSourceEventArgs e)
    {
        this.RadGrid1.DataSource = this.Customers;
    }

    private DataTable Customers
    {
        get
        {
            object obj = this.Session["Customers"];
            if ((!(obj == null)))
            {
                return ((DataTable)(obj));
            }
            DataTable myDataTable = new DataTable();
            myDataTable = GetDataTable("SELECT * FROM Customers");
            myDataTable.PrimaryKey = new DataColumn[] { myDataTable.Columns["CustomerID"] };
            this.Session["Customers"] = myDataTable;
            return myDataTable;
        }
    }
    private static DataTable GetDataTable(string query)
    {
        OleDbConnection connection1 = new OleDbConnection("Provider=Microsoft.Jet.OLEDB.4.0; Data Source=" + System.Web.HttpContext.Current.Server.MapPath("~/Nwind.mdb"));
        OleDbDataAdapter adapter1 = new OleDbDataAdapter();
        adapter1.SelectCommand = new OleDbCommand(query, connection1);
        DataTable table1 = new DataTable();
        connection1.Open();
        try
        {
            adapter1.Fill(table1);
        }
        finally
        {
            connection1.Close();
        }
        return table1;
    }
    
    private void UpdateHiddenInputValue()
    {
        string hiddenInputString = "";
        selectedIndexesPerPage = ((Hashtable)(Session["selectedIndexesPerPage"]));
        if(selectedItemsPerPage != null)
        {
            if (selectedIndexesPerPage[RadGrid1.MasterTableView.CurrentPageIndex] != null)
            {
                hiddenInputString = RadGrid1.MasterTableView.CurrentPageIndex + ":" + selectedIndexesPerPage[RadGrid1.MasterTableView.CurrentPageIndex].ToString();
            }
        }
        SelectedRowsData.Value = hiddenInputString;
    }
    
    private void UpdatePageSelectedItems()
    {
        selectedItemsPerPage = ((Hashtable) (Session["selectedItemsPerPage"]));
        selectedIndexesPerPage = ((Hashtable) (Session["selectedIndexesPerPage"]));
        if(selectedItemsPerPage != null)
        {
            Hashtable updatedSelectedItemsPerPage = new Hashtable();
            Hashtable updatedSelectedIndexesPerPage = new Hashtable();
            DataView dv = new DataView(this.Customers);
            if (RadGrid1.MasterTableView.SortExpressions.Count > 0)
                dv.Sort = RadGrid1.MasterTableView.SortExpressions[0].ToString();
            DataTable dt = dv.ToTable();
            dt.PrimaryKey = new DataColumn[] {dt.Columns["CustomerID"]};
            
            int itemsPerPage = RadGrid1.PageSize;
            foreach (int item in selectedItemsPerPage.Keys)
            {
                string[] idsArray = selectedItemsPerPage[item].ToString().Split(',');
                for (int i = 0; i < idsArray.Length; i++)
                {
                    int rowIndexInTable = dt.Rows.IndexOf(dt.Rows.Find(idsArray[i]));
                    int rowPage = rowIndexInTable/itemsPerPage;
                    int rowIndexInPage = (rowIndexInTable + 1)%itemsPerPage - 1;
                    if (updatedSelectedIndexesPerPage[rowPage] == null)
                    {
                        updatedSelectedIndexesPerPage[rowPage] = rowIndexInPage.ToString();
                        updatedSelectedItemsPerPage[rowPage] = idsArray[i].ToString();
                    }
                    else
                    {
                        updatedSelectedIndexesPerPage[rowPage] += "," + rowIndexInPage.ToString();
                        updatedSelectedItemsPerPage[rowPage] += "," + idsArray[i].ToString();
                    }
                }
            }
            Session["selectedItemsPerPage"] = updatedSelectedItemsPerPage;
            Session["selectedIndexesPerPage"] = updatedSelectedIndexesPerPage;
        }
    }

 
    private void SaveSelectedItemsPerPage()
    {
        if ((Session["selectedItemsPerPage"] == null))
        {
            selectedItemsPerPage = new Hashtable();
            selectedIndexesPerPage = new Hashtable();
        }
        else
        {
            selectedItemsPerPage = ((Hashtable)(Session["selectedItemsPerPage"]));
            selectedIndexesPerPage = ((Hashtable)(Session["selectedIndexesPerPage"]));
        }
        string selectedItems = "";
        string selectedIndexes = "";
        GridItemCollection selItems = RadGrid1.SelectedItems;
        for (int i = 0; i < selItems.Count; i++)
        {
            string customerID = (selItems[i] as GridDataItem)["CustomerID"].Text;
            selectedItems += customerID.ToString();
            selectedIndexes += selItems[i].ItemIndex;
            if (i < selItems.Count - 1)
            {
                selectedItems += ",";
                selectedIndexes += ",";
            }
        }
        if(selectedItems != "")
        {
            selectedItemsPerPage[RadGrid1.MasterTableView.CurrentPageIndex] = selectedItems;
            selectedIndexesPerPage[RadGrid1.MasterTableView.CurrentPageIndex] = selectedIndexes;
        }
    
        Session["selectedItemsPerPage"] = selectedItemsPerPage;
        Session["selectedIndexesPerPage"] = selectedIndexesPerPage;
    }
}
